#include <stdio.h>

int main()
{
    int i=0,j,D,P;
    long int N,Q;
    long long int l=0;
    scanf("%ld %ld",&N,&Q);
    long long int p[N];
    long long int d[N];
    long long int k[Q];
    long long int o[Q];
    for(i=0;i<N;i++)
    {
        scanf("%lld %lld",&d[i],&p[i]);
        l=l+p[i];
    }
    for(i=0;i<Q;i++)
    {
        scanf("%lld",&k[i]);
        o[i]=0;
    }

    for(j=0;j<Q;j++)
    {
        i=0;
        while(i<N)
        {
            if(k[j]<d[0])
            {

                o[j]=0;
                break;
            }
            if(k[j]<p[i])
            {
                o[j]=o[j]+1+k[j]-d[i];
                i++;
                continue;
            }
            if(k[j]>p[i]+d[i])
            {
                o[j]=o[i]+p[i];
                i++;
                continue;
            }
            if(i==0)
            {
               if(k[j]>p[i])
               {
                o[j]=o[j]+k[j]+1-d[i];
                i++;
                break;
               }
            }
            if(k[j]>p[i])
            {
                o[j]=o[j]+k[j]-d[i]+1;
                i++;
                continue;
            }
            i++;
        }
        if(k[j]>l)
        {
            o[j]=l;
            continue;
        }

    }
    for(i=0;i<Q;i++)
    {
        printf("%lld ",o[i]);
    }
}